<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>
<%@ include file="includes/sdkinit.jsp" %>
<%@ include file="includes/sdklogincheck.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="java.util.logging.*" %>
<%@ page import="com.esko.webcenter.src.filter.*" %>
<%@ page import="com.esko.webcenter.src.root.view.*"%>
<%@ page import="com.esko.webcenter.src.util.XMLUtils" %>
<%@ page import="com.esko.util.StringUtils" %>
<%@ page import="com.esko.util.VectorUtils" %>
<%@ page import="com.esko.webcenter.src.xml.*"%>
<%@ page import="com.esko.webcenter.src.root.*" %>
<%@ page import="com.esko.webcenter.src.util.*" %>
<%
	// === Start of the main scriplet ===
	
	String loginID = LoginMgr.getLoginMgr(session).getLoginID();
	String attrname = request.getParameter("attrname");
	String attrid = request.getParameter("attrid");	
	String type = request.getParameter("type");	
	//added verbose param so I can use simple attribute list xml dump for ajax call in attribute cattegory page. The default is verbose ON!!!
	String verboseStr = request.getParameter("verbose");
	boolean verbose = !StringUtils.checkForValue(verboseStr) || verboseStr.equalsIgnoreCase("1");
	
	AttributeMgrTM attributeMgrTM = DBTMUtils.findBean(response, session, AttributeMgrTM.class);	

	if (attributeMgrTM == null) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
		checkLogOff(session);		
		return;
	}

    Vector attributeList = null;
	Vector restrictedSetList = null;
	Vector attributeUnitList = null;
	
	try {
	    if (StringUtils.checkForValue(attrname) || StringUtils.checkForValue(attrid)) {
	    	// search for an attribute of the given name/id only
			Vector filterList = new Vector();
			Criteria criteriaOne = new Criteria();
			criteriaOne.setCategory(Parameters.Category.ATTRIBUTES);
	    	if (StringUtils.checkForValue(attrname)) {    	
			    criteriaOne.setField(AttributeParameters.Field.Name);
			    criteriaOne.setFromValue(attrname);
		    } else {
			    criteriaOne.setField(AttributeParameters.Field.ID);
			    criteriaOne.setFromValue(attrid);	    	
		    }
			filterList.addElement(criteriaOne);
			attributeList = attributeMgrTM.loadList(loginID, filterList);
		    
		    if (!VectorUtils.isEmptyOrNull(attributeList)) {
		    	Attribute attr = (Attribute)attributeList.elementAt(0);
		    	String rs_id = attr.getRestrictedSetID();
		    	String unit_id = attr.getUnitTypeID();
		    					
				RestrictedSetTM restrictedSetTM = DBTMUtils.findBean(response, session, RestrictedSetTM.class);
				AttributeUnitTM attributeUnitTM = DBTMUtils.findBean(response, session, AttributeUnitTM.class);
				
				if (restrictedSetTM == null || attributeUnitTM == null) {
					out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
					checkLogOff(session);		
					return;
				}
		    	
		    	// get restricted set info
		    	if (StringUtils.checkForValue(rs_id)) {
			    	RestrictedSet rs = restrictedSetTM.loadRestrictedSetWithValues(loginID, rs_id);
			    	if (rs != null) {
				    	restrictedSetList = new Vector();
				    	restrictedSetList.add(rs);
			    	}
		    	}
		    	// get unit info
		    	if (StringUtils.checkForValue(unit_id)) {
			    	AttributeUnit unit = attributeUnitTM.findByID(unit_id);
			    	if (unit != null) {
				    	attributeUnitList = new Vector();
				    	attributeUnitList.add(unit);
			    	}
		    	}
		    }
	    } else {
	    	// all attributes of the given type 		
			RestrictedSetMgrTM restrictedSetMgrTM = DBTMUtils.findBean(response, session, RestrictedSetMgrTM.class);
			AttributeUnitMgrTM attributeUnitMgrTM = DBTMUtils.findBean(response, session, AttributeUnitMgrTM.class);

			if (restrictedSetMgrTM == null || attributeUnitMgrTM == null) {
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
				checkLogOff(session);		
				return;
			}
			
			// always add attribute types filter
		   	Vector filterList = new Vector();
		   	String attrTypes = null;
		   	if(type != null && type.equals("task")) {
		   		attrTypes = String.valueOf(Attribute.AttributeTypes.Tasks); // Specifications only
		   	} else {
				attrTypes = String.valueOf(Attribute.AttributeTypes.DocsAndProjects); // Standard attributes, but NOT specification
		    }
		    Criteria criteriaOne = new Criteria();
		    criteriaOne.setCategory(Parameters.Category.ATTRIBUTES);
		    criteriaOne.setField(AttributeParameters.Field.Type);
		    criteriaOne.setFromValue(attrTypes);
		    filterList.addElement(criteriaOne);
	    
			attributeList = attributeMgrTM.loadList(loginID, filterList);
			restrictedSetList = restrictedSetMgrTM.loadList(loginID, null);
			attributeUnitList = attributeUnitMgrTM.loadList(loginID, null);			
		}
	}
	catch (WebCenterRemoteException ex) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ex));
		checkLogOff(session);
		return;
	}
	
	if (VectorUtils.isEmptyOrNull(attributeList)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_ATTR));
	} else {
		try {
			// write the xml
			out.write("<attributes>");
						
			AttributeListXml attributeListXML = new AttributeListXml();
			
			if (verbose) {
				//general and mostly used dump - all attributes' info
				attributeListXML.getInXml(attributeList, out);
			} else {
				//for attribute category page - dumps only id, name and deleted variables
				attributeListXML.getInXml_reduced(attributeList, out);
			}
						
			if (!VectorUtils.isEmptyOrNull(attributeUnitList)) {
				AttributeUnitListXml attributeUnitListXml = new AttributeUnitListXml();
				attributeUnitListXml.getInXml(attributeUnitList, out);
			}		
			if (!VectorUtils.isEmptyOrNull(restrictedSetList)) {
				RestrictedSetListXml restrictedSetListXml = new RestrictedSetListXml();
				if (verbose) {
					//general and mostly used dump - all attributes' info
					restrictedSetListXml.getInXml(restrictedSetList, out);
				} else {
					//for attribute category page - dumps only id, name and deleted variables
					restrictedSetListXml.getInXml_reduced(restrictedSetList, out);
				}
			}			
			out.write("</attributes>");
		}
		catch (XmlException xmlEx) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, xmlEx));
		}		
	}	
	
	checkLogOff(session);				
%>
